<!DOCTYPE html>
<html>

<head>
  <meta charset="UTF-8">
  <title>CRUD</title>
  <!-- main css -->
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T"
    crossorigin="anonymous">
  <link href="https://fonts.googleapis.com/css?family=Raleway" rel="stylesheet">
  <!-- end css -->
  <style>
        body {
          height: 100%;
          font-family: 'Raleway', sans-serif;
        }

        h1 {
          text-align: center;
          color: white;
          font-size: 18px;
        }
        input[type='submit'], button, [aria-label]{
        cursor: pointer;
        }
        #spoiler{
        display: none;
        }
</style>
</head>

<body>

  <!-- begin container -->
  <div class="container" style="padding-top: 20px;">
    <nav class="navbar navbar-light bg-primary">
      <a class="navbar-brand text-white" href="#">
        <h1><b>ToDoApp</b></h1>
      </a>
    </nav>

    <div class="card bg-light">
      <div class="card-body text-center">
        <section>
          <table class="container">
            <p id="counter"></p>
            <tr>
              <th>Name</th>
              <th>Edit Data</th>
              <th>Delete Data</th>
            </tr>
            <tbody id="names">
            </tbody>
          </table>
        </section>
      </div>

      <form action="javascript:void(0);" method="POST" onsubmit="app.Add()">
        <div class="form-group text-center">
          <input class="form-control-sm" type="text" id="add-name" placeholder="Input Text Here">
          <span class="text-center pb-2">
            <input class="btn btn-group-sm btn-success" type="submit" value="Add">
          </span>
        </div>
      </form>
      <div id="spoiler" role="aria-hidden">
        <form action="javascript:void(0);" method="POST" id="saveEdit">
          <div class="form-group text-center">
            <input class="form-control-sm" type="text" id="edit-name">
            <input class="btn btn-group-sm btn-success" type="submit" value="Edit" /> <a class="btn btn-group-sm btn-default"
              onclick="CloseInput()" aria-label="Close">&#10006;</a>
          </div>
        </form>
      </div>
    </div>
  </div>
  <!-- end container -->









  <!--  begin external javascript -->
  <script src="https://code.jquery.com/jquery-3.3.1.slim.min.js" integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo"
    crossorigin="anonymous"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js" integrity="sha384-UO2eT0CpHqdSJQ6hJty5KVphtPhzWj9WO1clHTMGa3JDZwrnQq4sF86dIHNDz0W1"
    crossorigin="anonymous"></script>
  <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js" integrity="sha384-JjSmVgyd0p3pXB1rRibZUAYoIIy6OrQ6VrjIEaFf/nJGzIxFDsf4x0xIM+B07jRM"
    crossorigin="anonymous"></script>
  <!-- end external javascript -->

  <!-- internal javascript -->
  <script>
    var app = new function () {
      this.el = document.getElementById('names');
      // parse data for localstorage to table listing
      this.names = localStorage.getItem('students') ? JSON.parse(localStorage.getItem('students')) : [];
      this.Count = function (data) {
        var el = document.getElementById('counter');
        var name = 'Number Of Students RN # 2';
        if (data) {
          if (data > 1) {
            name = 'Number Of Students RN # 2';
          }
          el.innerHTML = data + ' ' + name;
        } else {
          el.innerHTML = 'No ' + name;
        }
      };

      this.FetchAll = function () {
        var data = '';
        if (this.names.length > 0) {
          for (i = 0; i < this.names.length; i++) {
            data += '<tr>';
            data += '<td>' + this.names[i] + '</td>';
            data += '<td><button class="btn btn-group-sm btn-warning" onclick="app.Edit(' + i +
              ')">Edit</button></td>';
            data += '<td><button class="btn btn-group-sm btn-danger" onclick="app.Delete(' + i +
              ')">Delete</button></td>';
            data += '</tr>';
          }
        }
        this.Count(this.names.length);
        return this.el.innerHTML = data;
      };
      this.Add = function () {
        el = document.getElementById('add-name');
        // Get the value
        var country = el.value;
        if (country) {
          // Add the new value
          this.names.push(country.trim());
          // Reset input value
          el.value = '';
          // Dislay the new list
          this.FetchAll();
          // set data to localstorage
          localStorage.setItem("students", JSON.stringify(this.names));
        }
      };
      this.Edit = function (item) {
        var el = document.getElementById('edit-name');
        // Display value in the field
        el.value = this.names[item];
        // Display fields
        document.getElementById('spoiler').style.display = 'block';
        self = this;
        document.getElementById('saveEdit').onsubmit = function () {
          // Get value
          var country = el.value;
          if (country) {
            // Edit value
            self.names[item]= el.value;
            // set back into localstorage
            localStorage.setItem("students", JSON.stringify(self.names));
            // Display the new list
            self.FetchAll();
            // Hide fields
            CloseInput();
          }
        }
      };
      this.Delete = function (item) {
        // Delete the current row
        this.names.splice(item, 1);
        //set back into local storage
        localStorage.setItem("students", JSON.stringify(this.names));
        // Display the new list
        this.FetchAll();
      };

    }
    app.FetchAll();

    function CloseInput() {
      document.getElementById('spoiler').style.display = 'none';
    }
  </script>
  <!-- end internal javascript -->
</body>

</html>